--[[
    Author:Darcey@AllForTheCode.co.uk 
--]]

-- SavedVariableDefaults
if ( not DCoordsDBZ ) then 
	DCoordsDBZ = {};
	
	DCoordsDBZ["visible"] = true;
	
	DCoordsDBZ["FirstRun"] = true;
	
	DCoordsDBZ["updateDelay"] = 5;
	DCoordsDBZ["updateDelayInCombat"] = 40;
	DCoordsDBZ["updateDelayInDungeonOrRaid"] = 100;

	DCoordsDBZ["MainBar"] = {};
	DCoordsDBZ["MainBar"].visible = true;
	DCoordsDBZ["MainBar"].decimalPrecision = 2;
	DCoordsDBZ["MainBar"].alignmentIndex = 7;

	DCoordsDBZ["MainBar"].showZone = true;
	DCoordsDBZ["MainBar"].showSubZone = true;
	DCoordsDBZ["MainBar"].x = 0;
	DCoordsDBZ["MainBar"].y = 0;

	DCoordsDBZ["MainBar"].bgVisible = true;
	DCoordsDBZ["MainBar"].bgSelectedIndex = 1;
	DCoordsDBZ["MainBar"].bgR = 0;
	DCoordsDBZ["MainBar"].bgG = 0;
	DCoordsDBZ["MainBar"].bgB = 0;
	DCoordsDBZ["MainBar"].bgA = 0.5;
	DCoordsDBZ["MainBar"].paddingLeftRight = 0;
	DCoordsDBZ["MainBar"].paddingTopBottom = 7.5;

	DCoordsDBZ["MainBar"].fontSelectedIndex = 1;
	DCoordsDBZ["MainBar"].fontAlignmentIndex = 4; -- setPoint
	DCoordsDBZ["MainBar"].fontOffsetX = -0.1; -- setPoint
	DCoordsDBZ["MainBar"].fontOffsetY = 0.7; -- setPoint
	DCoordsDBZ["MainBar"].fontSelectedJustificationIndex = 1; -- text align
	DCoordsDBZ["MainBar"].fontSize = 14;
	DCoordsDBZ["MainBar"].fontR = 1;
	DCoordsDBZ["MainBar"].fontG = 1;
	DCoordsDBZ["MainBar"].fontB = 1;
	DCoordsDBZ["MainBar"].fontA = 1;

	DCoordsDBZ["WorldMap"] = {};
	DCoordsDBZ["WorldMap"].visible = true;
	DCoordsDBZ["WorldMap"].decimalPrecision = 2;
	DCoordsDBZ["WorldMap"].fontAlignmentIndex = 2; -- setPoint
	DCoordsDBZ["WorldMap"].fontOffsetY = 23; -- setPoint
	DCoordsDBZ["WorldMap"].fontSelectedIndex = 1;
	DCoordsDBZ["WorldMap"].fontSize = 18;
	DCoordsDBZ["WorldMap"].fontR = 1;
	DCoordsDBZ["WorldMap"].fontG = 1;
	DCoordsDBZ["WorldMap"].fontB = 1;
	DCoordsDBZ["WorldMap"].fontA = 1;
	
	DCoordsDBZ["MinimapLocationBar"] = {};
	DCoordsDBZ["MinimapLocationBar"].showLocationBar = true;
	DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled = true;
	DCoordsDBZ["MinimapLocationBar"].decimalPrecision = 2;
	DCoordsDBZ["MinimapLocationBar"].displayZone = false;
	DCoordsDBZ["MinimapLocationBar"].fontSelectedIndex = 1;
	DCoordsDBZ["MinimapLocationBar"].fontSize = 16;
	DCoordsDBZ["MinimapLocationBar"].fontR = 1;
	DCoordsDBZ["MinimapLocationBar"].fontG = 1;
	DCoordsDBZ["MinimapLocationBar"].fontB = 1;
	DCoordsDBZ["MinimapLocationBar"].fontA = 1;

	DCoordsDBZ["Objectives"] = {};
	DCoordsDBZ["Objectives"].enabled = false;
	DCoordsDBZ["Objectives"].alignmentIndex = 1;
	DCoordsDBZ["Objectives"].alpha = 0.7;
	DCoordsDBZ["Objectives"].scale = 0.8;
	DCoordsDBZ["Objectives"].height = 300;
	DCoordsDBZ["Objectives"].x = 0;
	DCoordsDBZ["Objectives"].y = 0;

end


--[[
	DCoordsDBZ["FontL"] = 12;
	DCoordsDBZ["FontN"] = 10;
	DCoordsDBZ["FontS"] = 8;
	--]]


-- Libs
DCoordsLSM = LibStub("LibSharedMedia-3.0")


-- Globals
DCoordsVersion = "4.3.18";
DCoordsDebug = false;
DCoordsTempText = "DCoords waiting for data"; --"DCoords v" .. DCoordsVersion;
DCoordsInCombat = false;
DCoordsMenuFontSize = 12;

DCoordsUIP = _G["UIParent"];

DCoordsGVar = {};

DCoordsGVar["DCZone"] = "ZONE";
DCoordsGVar["DCSubZone"] = "SUB ZONE";

DCoordsGVar["DCUIFontSize"] = 14;

DCoordsGVar["DCMainBarFrameName"] = nil;
DCoordsGVar["DCMainBar"] = nil;
DCoordsGVar["DCMainBarText"] = nil;
DCoordsGVar["DCWorldMapText"] = nil;

DCoordsGVar["DCOptions"] = nil;

DCoordsGVar["DCLoaded"] = false;
DCoordsGVar["DCVarsLoaded"] = false;

DCoordsGVar["DCReady"] = false;
DCoordsGVar["IsInCombat"] = false;

DCoordsGVar["fontPath"] = "Interface\\Addons\\DCoords\\Fonts\\";
DCoordsGVar["fontFiles"]  = {
	"AccidentalPresidency.ttf",
	"Lora-Regular.ttf",
	"Montserrat-Regular.ttf",
	"OpenSans-CondBold.ttf",
	"OpenSans-CondLight.ttf",
	"OpenSans-CondLightItalic.ttf",
	"MORPHEUS.TTF",
	"NotoSans-Bold.ttf",
	"NotoSans-Italic.ttf",
	"NotoSans-Regular.ttf",
	"stonehen.ttf",
	"tiffanynormal.ttf",
	"ARAMIS.TTF",
	"BRAVADO.TTF",
	"DIGIWOI_.TTF"
}
DCoordsGVar["noOfFonts"] = 15; -- LUA doesn't have .length()! WTF

--DCoordsGVar["AlignmentOptions"] = {"TOPLEFT","TOP","TOPRIGHT","LEFT","CENTER","RIGHT","BOTTOMLEFT","BOTTOM","BOTTOMRIGHT"};
DCoordsGVar["AlignmentOptions"] = {"TOPLEFT","TOP","TOPRIGHT","LEFT","CENTER","RIGHT","BOTTOMLEFT","BOTTOM","BOTTOMRIGHT"};
DCoordsGVar["WorldMapAlignmentOptions"] = {"TOP","BOTTOM"};
DCoordsGVar["JustificationOptions"] = {"LEFT","CENTER","RIGHT"};

-- Register fonts
for i=1,#DCoordsGVar["fontFiles"] do
	local fPath = DCoordsGVar["fontPath"]..DCoordsGVar["fontFiles"][i];
	--print(fPath);
	DCoordsLSM:Register ("font", "Font " .. tostring(i), fPath)
end

DCoordsUpdateFrame = nil;




function initVars()
	log("initVars()");
	
	DCoordsDBZ = nil;
	DCoordsDBZ = {};
	
	DCoordsDBZ["visible"] = true;
	
	DCoordsDBZ["updateDelay"] = 5;
	DCoordsDBZ["updateDelayInCombat"] = 40;
	DCoordsDBZ["updateDelayInDungeonOrRaid"] = 100;
	
	DCoordsDBZ["FirstRun"] = true;

	DCoordsDBZ["MainBar"] = {};
	DCoordsDBZ["MainBar"].visible = true;
	DCoordsDBZ["MainBar"].decimalPrecision = 2;
	DCoordsDBZ["MainBar"].alignmentIndex = 7;

	DCoordsDBZ["MainBar"].showZone = true;
	DCoordsDBZ["MainBar"].showSubZone = true;
	DCoordsDBZ["MainBar"].x = 0;
	DCoordsDBZ["MainBar"].y = 0;

	DCoordsDBZ["MainBar"].bgVisible = true;
	DCoordsDBZ["MainBar"].bgSelectedIndex = 1;
	DCoordsDBZ["MainBar"].bgR = 0;
	DCoordsDBZ["MainBar"].bgG = 0;
	DCoordsDBZ["MainBar"].bgB = 0;
	DCoordsDBZ["MainBar"].bgA = 0.5;
	DCoordsDBZ["MainBar"].paddingLeftRight = 0;
	DCoordsDBZ["MainBar"].paddingTopBottom = 7.5;

	DCoordsDBZ["MainBar"].fontSelectedIndex = 1;
	DCoordsDBZ["MainBar"].fontAlignmentIndex = 4; -- setPoint
	DCoordsDBZ["MainBar"].fontOffsetX = -0.1; -- setPoint
	DCoordsDBZ["MainBar"].fontOffsetY = 0.7; -- setPoint
	DCoordsDBZ["MainBar"].fontSelectedJustificationIndex = 1; -- text align
	DCoordsDBZ["MainBar"].fontSize = 16;
	DCoordsDBZ["MainBar"].fontR = 1;
	DCoordsDBZ["MainBar"].fontG = 1;
	DCoordsDBZ["MainBar"].fontB = 1;
	DCoordsDBZ["MainBar"].fontA = 1;

	DCoordsDBZ["WorldMap"] = {};
	DCoordsDBZ["WorldMap"].visible = true;
	DCoordsDBZ["WorldMap"].decimalPrecision = 2;
	DCoordsDBZ["WorldMap"].fontAlignmentIndex = 2; -- setPoint
	DCoordsDBZ["WorldMap"].fontOffsetY = 23; -- setPoint
	DCoordsDBZ["WorldMap"].fontSelectedIndex = 1;
	DCoordsDBZ["WorldMap"].fontSize = 18;
	DCoordsDBZ["WorldMap"].fontR = 1;
	DCoordsDBZ["WorldMap"].fontG = 1;
	DCoordsDBZ["WorldMap"].fontB = 1;
	DCoordsDBZ["WorldMap"].fontA = 1;
	
	DCoordsDBZ["MinimapLocationBar"] = {};
	DCoordsDBZ["MinimapLocationBar"].showLocationBar = true;
	DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled = true;
	DCoordsDBZ["MinimapLocationBar"].decimalPrecision = 2;
	DCoordsDBZ["MinimapLocationBar"].displayZone = false;
	DCoordsDBZ["MinimapLocationBar"].fontSelectedIndex = 1;
	DCoordsDBZ["MinimapLocationBar"].fontSize = 14;
	DCoordsDBZ["MinimapLocationBar"].fontR = 1;
	DCoordsDBZ["MinimapLocationBar"].fontG = 1;
	DCoordsDBZ["MinimapLocationBar"].fontB = 1;
	DCoordsDBZ["MinimapLocationBar"].fontA = 1;
	
	DCoordsDBZ["Objectives"] = {};
	DCoordsDBZ["Objectives"].enabled = false;
	DCoordsDBZ["Objectives"].alignmentIndex = 1;
	DCoordsDBZ["Objectives"].alpha = 0.7;
	DCoordsDBZ["Objectives"].scale = 0.8;
	DCoordsDBZ["Objectives"].height = 300;
	DCoordsDBZ["Objectives"].x = 0;
	DCoordsDBZ["Objectives"].y = 0;
	
	
	-- Reset minimap visual state
	MiniMapWorldMapButton:Show()
	MinimapZoneTextButton:Show();
	MinimapBorder:Show()
	MinimapBorderTop:Show()
	MinimapZoneText:Show();
	Minimap:SetMaskTexture("Textures\\MinimapMask"); --default
end
