--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initObjectiveTracker()
    log("initObjectiveTracker()");
    
    if ( DCoordsDBZ["Objectives"].enabled ) then
        enableDragOfObjectivesTracker();
        sliderObjectivesAlphaChangeHandler( DCoordsDBZ["Objectives"].alpha );
        sliderObjectivesScaleChangeHandler(  DCoordsDBZ["Objectives"].scale );
        sliderObjectivesHeightChangeHandler( DCoordsDBZ["Objectives"].height );
    else
        DCoordsDBZ["Objectives"].x = 0;
	    DCoordsDBZ["Objectives"].y = 0;
    end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function cbDragObjectivesChangeHandler(value)
    --log("cbDragObjectivesChangeHandler(value:"..tostring(value)..")");
    DCoordsDBZ["Objectives"].enabled = value;
    
    if ( DCoordsDBZ["Objectives"].enabled ) then
        initObjectiveTracker();
    else
        ReloadUI();
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderObjectivesAlphaChangeHandler(value)
    -- Prevent run if disabled
    if ( DCoordsDBZ["Objectives"].enabled == false ) then
        return;
    end
    
    DCoordsDBZ["Objectives"].alpha = value;
    ObjectiveTrackerFrame:SetAlpha( DCoordsDBZ["Objectives"].alpha );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderObjectivesHeightChangeHandler(value)
    -- Prevent run if disabled
    if ( DCoordsDBZ["Objectives"].enabled == false ) then
        return;
    end
    
    DCoordsDBZ["Objectives"].height = value;
    ObjectiveTrackerFrame:SetHeight( DCoordsDBZ["Objectives"].height );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderObjectivesScaleChangeHandler(value)
    -- Prevent run if disabled
    if ( DCoordsDBZ["Objectives"].enabled == false ) then
        return;
    end
    
    DCoordsDBZ["Objectives"].scale = value;
    ObjectiveTrackerFrame:SetScale( DCoordsDBZ["Objectives"].scale );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #























-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function enableDragOfObjectivesTracker()
    --log("enableDragOfObjectivesTracker()");
        

	if (ObjectiveTrackerFrame) then
		ObjectiveTrackerFrame:EnableMouse(true);
		ObjectiveTrackerFrame:SetResizable(true);
		ObjectiveTrackerFrame:SetMovable(true);

		if (not DCoordsDBZ["Objectives"].x) then
			DCoordsDBZ["Objectives"].x = ObjectiveTrackerFrame:GetLeft();
			DCoordsDBZ["Objectives"].y = ObjectiveTrackerFrame:GetTop();
                  
            DCoordsDBZ["Objectives"].x = 50;
			DCoordsDBZ["Objectives"].y = 50;
		end
            
		ObjectiveTrackerFrame:ClearAllPoints()
		ObjectiveTrackerFrame.ClearAllPoints = function() end
		ObjectiveTrackerFrame:SetPoint("BOTTOMLEFT",DCoordsDBZ["Objectives"].x,DCoordsDBZ["Objectives"].y);
		ObjectiveTrackerFrame.SetPoint = function() end

		ObjectiveTrackerFrame:RegisterForDrag("LeftButton");
		ObjectiveTrackerFrame:SetScript("OnDragStart", function(self)
            if (IsShiftKeyDown()) then 
                toChat("DCoords: Objective tracker drag started!");
                self:StartMoving();
            end 
		end);

		ObjectiveTrackerFrame:SetScript("OnDragStop", function(self)
			if (not DCoordsDBZ["Objectives"]) then
				DCoordsDBZ["Objectives"].x = 0;
				DCoordsDBZ["Objectives"].y = 0;
			else	
				DCoordsDBZ["Objectives"].x = ObjectiveTrackerFrame:GetLeft();
				DCoordsDBZ["Objectives"].y = ObjectiveTrackerFrame:GetTop()-ObjectiveTrackerFrame:GetHeight();
			end
			--log(DCoordsDBZ["Objectives"].x  .. "," .. DCoordsDBZ["Objectives"].y );
			self:StopMovingOrSizing()
		end);
		
	end
    
    --DCoordsDBZ["Objectives"].x = 0;
    --log(DCoordsDBZ["Objectives"].x  .. "," .. DCoordsDBZ["Objectives"].y );

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


